"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const child_process_1 = require("child_process");
const ramda_1 = tslib_1.__importDefault(require("ramda"));
const fmtNull = (x) => x == null ? null : x;
const fmtStdIO = (buf) => {
    if (buf == null)
        return null;
    const str = String(buf);
    return str.trim() ? `\n${str}\n` : '((EMPTY))';
};
exports.createSpawnFunc = (command) => ramda_1.default.partial(child_process_1.spawnSync, [command]);
function spawn(fn, argv = [], options = {}) {
    const { status, signal, error, stdout, stderr } = fn(argv, options);
    return {
        status: fmtNull(status),
        signal: fmtNull(signal),
        error: fmtNull(error),
        stdout: fmtStdIO(stdout),
        stderr: fmtStdIO(stderr)
    };
}
exports.spawn = spawn;
(function (spawn) {
    spawn.withCommand = (command, argv, options) => spawn(exports.createSpawnFunc(command), argv, options);
})(spawn = exports.spawn || (exports.spawn = {}));
exports.default = spawn;
//# sourceMappingURL=spawn.js.map